--- scripts/casper 2013-01-07 23:16:59.000000000 +0100
+++ scripts/casper 2013-01-07 23:16:59.000000000 +0100
@@ -71,6 +71,8 @@
                 export CMD_USERFULLNAME="${x#userfullname=}" ;;
             username=*)
                 export CMD_USERNAME="${x#username=}" ;;
+            nfscow=*)
+                export NFS_COW="${x#nfscow=}";;
         esac
     done
     if [ "${UNIONFS}" = "" ]; then
@@ -453,7 +455,33 @@
         fi
     fi
 
-    mount -t ${cow_fstype} -o ${cow_mountopt} ${cowdevice} /cow || panic "Can not mount $cowdevice on /cow"
+    if [ -n "${NFS_COW}" ] && [ -z "${NOPERSISTENT}" ]; then
+        # check if there are any nfs options
+        if echo ${NFS_COW}|grep -q ','
+        then
+            nfs_cow_opts="-o nolock,$(echo ${NFS_COW}|cut -d, -f2-)"
+            nfs_cow=$(echo ${NFS_COW}|cut -d, -f1)
+        else
+            nfs_cow_opts="-o nolock"
+            nfs_cow=${NFS_COW}
+        fi
+        mac="$(get_mac)"
+        if [ -n "${mac}" ]
+        then
+            cowdevice=$(echo ${nfs_cow}|sed "s/client_mac_address/${mac}/")
+            cow_fstype="nfs"
+        else
+            panic "unable to determine mac address"
+        fi
+        
+        if [ "${cow_fstype}" = "nfs" ]
+        then
+            log_begin_msg "Trying nfsmount ${nfs_cow_opts} ${cowdevice} /cow"
+            nfsmount ${nfs_cow_opts} ${cowdevice} /cow || panic "Can not mount ${cowdevice} (n: ${cow_fstype}) on /cow"
+        else
+            mount -t ${cow_fstype} -o ${cow_mountopt} ${cowdevice} /cow || panic "Can not mount $cowdevice on /cow"
+        fi
+    fi
 
     case ${UNIONFS} in
         unionfs-fuse)

